<?php
/**
 * Copyright (c) 2019. IOWEB TECHNOLOGIES
 */

namespace Ioweb\Base\Controller\Index;

    use Magento\Catalog\Model\ProductRepository;
    use Magento\Framework\App\Action\Context;
    use Magento\Framework\Exception\NoSuchEntityException;
    use Magento\Framework\View\Result\PageFactory;
    use Magento\Framework\App\Action\Action;
    use Psr\Log\LoggerInterface;

    /**
     * Class Index
     * @package Ioweb\Base\Controller\Index\Product
     */
    class Product extends Action
    {

        protected $productRepository;

        /**
         * Index resultPageFactory
         * @var PageFactory
         */
        protected $resultPageFactory;

        protected $logger;

        /**
         * Index constructor.
         * @param Context $context
         * @param PageFactory $resultPageFactory
         */
        public function __construct(Context $context, PageFactory $resultPageFactory, ProductRepository $productRepository, LoggerInterface $logger)
        {
            $this->resultPageFactory = $resultPageFactory;
            $this->productRepository = $productRepository;
            $this->logger = $logger;
            return parent::__construct($context);
        }

        /**
         * Function execute
         * @return \Magento\Framework\View\Result\Page
         * @throws
         */
        public function execute()
        {
            for($i = 0 ; $i< 50000; $i++){
                try{
                    $this->logger->notice('ioweb saving product ' . $i);
                    $product = $this->productRepository->getById($i);
                    $this->productRepository->save($product);
                }
                catch (NoSuchEntityException $noSuchEntityException){
                    continue;
                }
            }
            return $this->resultPageFactory->create();
        }
    }
