<?php
    /**
     * Copyright (c) 2019. IOWEB TECHNOLOGIES
     */

    /**
     * Created by IntelliJ IDEA.
     * User: gabtz
     * Date: 9/2/2019
     * Time: 8:16 μμ
     */

    namespace Ioweb\Base\Controller\Index;

    use Magento\Catalog\Api\Data\ProductAttributeInterface;
    use Magento\Catalog\Model\Product\AttributeSet\Options;
    use Magento\Catalog\Model\ProductRepository;
    use Magento\Eav\Api\AttributeManagementInterface;
    use Magento\Eav\Model\AttributeSetRepository;
    use Magento\Framework\App\Action\Context;
    use Magento\Framework\View\Result\PageFactory;
    use Magento\Store\Model\StoreManagerInterface;
    use Psr\Log\LoggerInterface;


    class Sets extends \Magento\Framework\App\Action\Action
    {
        protected $productRepository;

        /**
         * Index resultPageFactory
         * @var PageFactory
         */
        protected $resultPageFactory;

        protected $logger;

        protected $attributeSetRepository;

        protected $attributeSetSearchResults;

        protected $options;

        /**
         * Index constructor.
         * @param Context $context
         * @param PageFactory $resultPageFactory
         */
        public function __construct(
            Context $context,
            PageFactory $resultPageFactory,
            ProductRepository $productRepository,
            LoggerInterface $logger,
            Options $options,
            StoreManagerInterface $storeManager,
            AttributeSetRepository $attributeSetRepository,
            AttributeManagementInterface $attributeManagement
        )
        {
            $storeManager->setCurrentStore(0);

            $this->resultPageFactory = $resultPageFactory;
            $this->productRepository = $productRepository;
            $this->logger = $logger;
            $this->options = $options;
            $this->storeManager = $storeManager;
            $this->attributeSetRepository = $attributeSetRepository;
            $this->attributeManagement = $attributeManagement;
            return parent::__construct($context);
        }

        public function execute()
        {
            $this->storeManager->setCurrentStore(0);
            $sets = $this->options->toOptionArray();
            $html = <<<HTML
            <!DOCTYPE html>
            <html>
       
<head>
<style>
    tr:nth-child(2n){
    background: #ddd;
    }
    
    td{
    vertical-align: top;
    }
</style>     
</head>
<body>
HTML;

            $html .= '<table>';

            foreach ($sets as $index => $data) {
                $html .=  '<tr>';
                $html .=  '<td>';
                $html .=  $data['label'];
                $html .=  '</td>';
                $html .=  '<td>';
                $atts = $this->attributeManagement->getAttributes(ProductAttributeInterface::ENTITY_TYPE_CODE, $data['value']);
                foreach ($atts as $att) {
                    $html .=  $att->getAttributeCode();
                    $html .=  '<br />';
                }
                $html .=  '</td>';
                $html .=  '</tr>';
            }
            $html .=  '</table>';
            $html .=  '</body>
</html>
';
            $resultFactory = $this->resultFactory->create(\Magento\Framework\Controller\ResultFactory::TYPE_RAW)->setHeader('Content-Type', 'text/html');
            $resultFactory->setContents($html);
//            $resultFactory->setContents('test');
            return $resultFactory;
        }

    }