<?php
/**
 * Copyright (c) 2020. IOWEB TECHNOLOGIES
 */

namespace Ioweb\Base\Helper;


use Magento\Framework\App\Helper\AbstractHelper;
use Magento\Framework\App\Helper\Context;
use Magento\Framework\App\ProductMetadata;

class App extends AbstractHelper
{
    protected $productMetadata;

    public function __construct(Context $context, ProductMetadata $productMetadata)
    {
        parent::__construct($context);
        $this->productMetadata = $productMetadata;
    }

    public function getVersion(){
        return $this->productMetadata->getVersion();
    }

    /**
     * @param $ver
     * @param string $operator
     *
     * @return mixed
     */
    public function versionCompare($ver, $operator = '>=')
    {
        $version = $this->productMetadata->getVersion(); //will return the magento version
        return version_compare($version, $ver, $operator);
    }


}