<?php
/*
 * Copyright (c) 2022. IOWEB TECHNOLOGIES
 */

namespace Ioweb\Base\Helper;


use Magento\Framework\App\CacheInterface;

class Lock
{
    protected $cache;

    public function __construct(
        CacheInterface $cache
    )
    {
        $this->cache = $cache;
    }

    /**
     * @param string $identifier
     * @return bool
     */
    public function acquire($identifier, $ttl = 60)
    {
        if ($this->cache->load($identifier) !== false) {
            return false;
        } else {
            $saved = $this->cache->save("1", $identifier, [], $ttl);
            return $saved;
        }
    }

    public function release($identifier)
    {
        return $this->cache->remove($identifier);
    }

    public function renew($identifier, $ttl)
    {
        return $this->cache->save("1", $identifier, [], $ttl);
    }
}