<?php
/*
 * Copyright (c) 2022. IOWEB TECHNOLOGIES
 * 'type' => 'int',
    'backend' => '',
    'frontend' => '',
    'label' => $code,
    'input' => $input,
    'class' => '',
    'source' => $source,
    'global' => $global,
    'visible' => $visible,
    'required' => $required,
    'user_defined' => $userDefined,
    'default' => $default,
    'searchable' => $searchable,
    'filterable' => $filterable,
    'comparable' => $comparable,
    'visible_on_front' => $visibleInFront,
    'used_in_product_listing' => true,
    'unique' => $unique,
    'apply_to' => '',
 */

namespace Ioweb\Base\Model;


use Ioweb\Base\Api\AttributeSetupDataInterface;
use Magento\Catalog\Model\AbstractModel;
use Magento\Eav\Model\Entity\Attribute\ScopedAttributeInterface;

class AttributeSetupData extends AbstractModel implements AttributeSetupDataInterface
{

    /** @inheridoc  */
    public function setApplyTo($applyTo)
    {
        return $this->setData(self::KEY_APPLY_TO, $applyTo);
    }

    /** @inheridoc  */
    public function getApplyTo()
    {
        return $this->getData(self::KEY_APPLY_TO);
    }

    /** @inheridoc  */
    public function setBackend($backend)
    {
        return $this->setData(self::KEY_BACKEND, $backend);
    }

    /** @inheridoc  */
    public function getBackend()
    {
        return $this->getData(self::KEY_BACKEND);
    }

    /** @inheridoc  */
    public function setClass($class)
    {
        return $this->setData(self::KEY_CLASS, $class);
    }

    /** @inheridoc  */
    public function getClass()
    {
        return $this->getData(self::KEY_CLASS);
    }

    /** @inheridoc  */
    public function setComparable($comparable)
    {
        return $this->setData(self::KEY_COMPARABLE, $comparable);
    }

    /** @inheridoc  */
    public function getComparable()
    {
        return $this->getData(self::KEY_COMPARABLE);
    }

    /** @inheridoc  */
    public function setDefault($default)
    {
        return $this->setData(self::KEY_DEFAULT, $default);
    }

    /** @inheridoc  */
    public function getDefault()
    {
        return $this->getData(self::KEY_DEFAULT);
    }

    /** @inheridoc  */
    public function setFilterable($filterable)
    {
        return $this->setData(self::KEY_FILTERABLE, $filterable);
    }

    /** @inheridoc  */
    public function getFilterable()
    {
        return $this->getData(self::KEY_FILTERABLE);
    }

    /** @inheridoc  */
    public function setFrontend($frontend)
    {
        return $this->setData(self::KEY_FRONTEND, $frontend);
    }

    /** @inheridoc  */
    public function getFrontend()
    {
        return $this->getData(self::KEY_FRONTEND);
    }

    /** @inheridoc  */
    public function setGlobal($global)
    {
        return $this->setData(self::KEY_GLOBAL, $global);
    }

    /** @inheridoc  */
    public function getGlobal()
    {
        return $this->getData(self::KEY_GLOBAL);
    }

    /** @inheridoc  */
    public function setInput($input)
    {
        return $this->setData(self::KEY_INPUT, $input);
    }

    /** @inheridoc  */
    public function getInput()
    {
        return $this->getData(self::KEY_INPUT);
    }

    /** @inheridoc  */
    public function setLabel($label)
    {
        return $this->setData(self::KEY_LABEL, $label);
    }

    /** @inheridoc  */
    public function getLabel()
    {
        return $this->getData(self::KEY_LABEL);
    }

    /** @inheridoc  */
    public function setRequired($required)
    {
        return $this->setData(self::KEY_REQUIRED, $required);
    }

    /** @inheridoc  */
    public function getRequired()
    {
        return $this->getData(self::KEY_REQUIRED);
    }

    /** @inheridoc  */
    public function setSearchable($searchable)
    {
        return $this->setData(self::KEY_SEARCHABLE, $searchable);
    }

    /** @inheridoc  */
    public function getSearchable()
    {
        return $this->getData(self::KEY_SEARCHABLE);
    }

    /** @inheridoc  */
    public function setSource($source)
    {
        return $this->setData(self::KEY_SOURCE, $source);
    }

    /** @inheridoc  */
    public function getSource()
    {
        return $this->getData(self::KEY_SOURCE);
    }

    /** @inheridoc  */
    public function setType($type)
    {
        return $this->setData(self::KEY_TYPE, $type);
    }

    /** @inheridoc  */
    public function getType()
    {
        return $this->getData(self::KEY_TYPE);
    }

    /** @inheridoc  */
    public function setUnique($unique)
    {
        return $this->setData(self::KEY_UNIQUE, $unique);
    }

    /** @inheridoc  */
    public function getUnique()
    {
        return $this->getData(self::KEY_UNIQUE);
    }

    /** @inheridoc  */
    public function setUsedInProductListing($usedInProductListing)
    {
        return $this->setData(self::KEY_USED_IN_PRODUCT_LISTING, $usedInProductListing);
    }

    /** @inheridoc  */
    public function getUsedInProductListing()
    {
        return $this->getData(self::KEY_USED_IN_PRODUCT_LISTING);
    }

    /** @inheridoc  */
    public function setUserDefined($userDefined)
    {
        return $this->setData(self::KEY_USER_DEFINED, $userDefined);
    }

    /**
     * @return string
     */
    public function getUserDefined()
    {
        return $this->getData(self::KEY_USER_DEFINED);
    }

    /** @inheridoc  */
    public function setVisible($visible)
    {
        $this->setData(self::KEY_IS_VISIBLE, $visible);
        return $this->setData(self::KEY_VISIBLE, $visible);
    }

    /** @inheridoc  */
    public function getVisible()
    {
        return $this->getData(self::KEY_VISIBLE);
    }

    /** @inheridoc  */
    public function setVisibleInFront($visibleInFront)
    {
        return $this->setData(self::KEY_VISIBLE_IN_FRONT, $visibleInFront);
    }

    /** @inheridoc  */
    public function getVisibleInFront()
    {
        return $this->getData(self::KEY_VISIBLE_IN_FRONT);
    }


    /** @inheritDoc  */
    public function getIsUsedInGrid()
    {
        return $this->getData(self::KEY_IS_USED_IN_GRID);
    }

    /** @inheritDoc  */
    public function setIsUsedInGrid($isUsedInGrid)
    {
        return $this->setData(self::KEY_IS_USED_IN_GRID, $isUsedInGrid);
    }
}