<?php
/**
 * Copyright (c) 2017. IOWEB TECHNOLOGIES
 */

    /**
     * Created by IntelliJ IDEA.
     * User: gabtz
     * Date: 4/12/2017
     * Time: 9:05 μμ
     */

    namespace Ioweb\Base\Model\Config\Source;


    use Magento\Catalog\Model\Category\Interceptor;
    use Magento\Catalog\Model\ResourceModel\Category\CollectionFactory;
    use Magento\Framework\Data\OptionSourceInterface;
    use Magento\Framework\Exception\LocalizedException;
    use Magento\Framework\Option\ArrayInterface;

    class Category implements OptionSourceInterface
    {


        /**
         * @var CollectionFactory
         */
        protected $_categoryCollectionFactory;

        /**
         * @var $categoryList array
         */
        protected $categoryList;

        public function __construct(CollectionFactory $categoryCollectionFactory)
        {
            $this->_categoryCollectionFactory = $categoryCollectionFactory;
        }

        /*
         * Option getter
         * @return array
         */
        public function toOptionArray()
        {


            $arr = $this->toArray();
            $ret = [];

            foreach ($arr as $key => $value)
            {

                $ret[] = [
                    'value' => $key,
                    'label' => $value
                ];
            }

            return $ret;
        }

        /*
         * Get options in "key-value" format
         * @return array
         */
        public function toArray()
        {

            /**
             * @var $categories
             */
            $categories = $this->_categoryCollectionFactory->create();
            try {
                $categories
                    ->addAttributeToSelect('*')
                    ->addIsActiveFilter()
                    ->addRootLevelFilter()
                ;
            } catch (LocalizedException $e) {

            }

            if(empty($categories))
                return $this->categoryList;

            foreach ($categories as $category){
                $this->pushChild($category);
            }

            $this->categoryList[-1]='---NONE----';

            return $this->categoryList;
        }

        /**
         * @param $category Interceptor
         */
        public function pushChild($category){
            $level = $category->getLevel();
            $levelPrefix = '';
            if($level>2)
                $levelPrefix = '|__ ';
            while($level>2){
                $levelPrefix .= ' __ ';
                $level--;
            }
            $this->categoryList[$category->getId()] = $levelPrefix . (string)$category->getId() . '. ' . $category->getName();
            $childCategories = $category->getChildrenCategories();
            if(empty($childCategories))
                return;
            foreach($childCategories as $childCategory){
                $this->pushChild($childCategory);
            }
        }

    }