<?php
/**
 * Copyright (c) 2017. IOWEB TECHNOLOGIES
 */

/**
 * Created by IntelliJ IDEA.
 * User: gabtz
 * Date: 4/12/2017
 * Time: 9:05 μμ
 */

namespace Ioweb\Base\Model\Config\Source;


use Magento\Cms\Model\PageRepository;
use Magento\Framework\Api\Search\SearchCriteriaInterfaceFactory;
use Magento\Framework\Data\OptionSourceInterface;

class CmsPage implements OptionSourceInterface
{


    private $pageRepository;

    private $searchCriteriaInterfaceFactory;

    public function __construct(
      PageRepository $pageRepository,
      SearchCriteriaInterfaceFactory $searchCriteriaInterfaceFactory
    ) {
        $this->pageRepository = $pageRepository;
        $this->searchCriteriaInterfaceFactory = $searchCriteriaInterfaceFactory;
    }

    /*
     * Option getter
     * @return array
     */
    public function toOptionArray()
    {
        $searchCriteria = $this->searchCriteriaInterfaceFactory->create();
        $searchResults = $this->pageRepository->getList($searchCriteria);
        $items = $searchResults->getItems();

        $ret = [];

        foreach ($items as $key => $item) {
            $ret[] = [
              'value' => $item->getId(),
              'label' => $item->getId().' - '.$item->getTitle(),
            ];
        }

        return $ret;
    }

}