<?php
    /**
 * Copyright (c) 2019. IOWEB TECHNOLOGIES
 */

    /**
     * Created by IntelliJ IDEA.
     * User: gabtz
     * Date: 4/12/2017
     * Time: 9:05 μμ
     */

    namespace Ioweb\Base\Model\Config\Source;


    use Magento\Eav\Model\Attribute;
    use Magento\Eav\Model\Config;
    use Magento\Eav\Model\ResourceModel\Entity\Attribute\CollectionFactory;
    use Magento\Framework\Api\SearchCriteria;
    use Magento\Framework\Data\OptionSourceInterface;
    use Magento\Framework\Option\ArrayInterface;
    use Magento\Payment\Api\PaymentMethodListInterface;
    use Magento\Store\Api\Data\StoreInterface;
    use Magento\Store\Model\StoreManagerInterface;

    class PaymentMethod implements OptionSourceInterface
    {


        protected $paymentMethodList;
        protected $searchCriteria;
        protected $storeManager;
        public function __construct(PaymentMethodListInterface $paymentMethodList, SearchCriteria $searchCriteria, StoreManagerInterface $storeManager)
        {
            $this->paymentMethodList = $paymentMethodList;
            $this->searchCriteria = $searchCriteria;
            $this->storeManager  = $storeManager;

        }

        /*
         * Option getter
         * @return array
         */
        public function toOptionArray()
        {


            $arr = $this->toArray();
            $ret = [];

            foreach ($arr as $key => $value) {

                $ret[] = [
                    'value' => $key,
                    'label' => $value,
                ];
            }

            return $ret;
        }

        /*
         * Get options in "key-value" format
         * @return array
         */
        public function toArray()
        {
            $arr = [];
            /**
             * @var $paymentMethodsList \Magento\Payment\Api\Data\PaymentMethodInterface[]
             */
            $paymentMethodsList = $this->paymentMethodList->getList($this->storeManager->getStore()->getId());
            foreach($paymentMethodsList as $paymentMethod){
                $arr[sprintf("%s (%s)", $paymentMethod->getCode(), $paymentMethod->getTitle())] = $paymentMethod->getCode();
            }
            return $arr;

        }

    }