<?php
    /**
     * Copyright (c) 2017. IOWEB TECHNOLOGIES
     */

    /**
     * Created by IntelliJ IDEA.
     * User: gabtz
     * Date: 4/12/2017
     * Time: 9:05 μμ
     */

    namespace Ioweb\Base\Model\Config\Source;


    use Magento\Eav\Model\Attribute;
    use Magento\Eav\Model\Config;
    use Magento\Eav\Model\ResourceModel\Entity\Attribute\CollectionFactory;
    use Magento\Framework\Api\SortOrder;
    use Magento\Framework\Data\OptionSourceInterface;
    use Magento\Framework\Option\ArrayInterface;

    class ProductAttribute implements OptionSourceInterface
    {


        /**
         * @var CollectionFactory
         */
        protected $_attributeCollectionFactory;

        protected $_eavConfig;

        /**
         * @var $categoryList array
         */
        protected $_attributeList;

        public function __construct(CollectionFactory $attributeCollectionFactory, Config $eavConfig)
        {
            $this->_attributeCollectionFactory = $attributeCollectionFactory;
            $this->eavConfig = $eavConfig;
        }

        /*
         * Option getter
         * @return array
         */
        public function toOptionArray()
        {


            $arr = $this->toArray();
            $ret = [];

            $ret[] = [
                'value' => '',
                'label' => '-NONE-'
            ];

            foreach ($arr as $key => $value) {

                $ret[] = [
                    'value' => $key,
                    'label' => $value,
                ];
            }
            return $ret;
        }

        /*
         * Get options in "key-value" format
         * @return array
         */
        public function toArray()
        {

            $entityTypeId = $this->eavConfig->getEntityType(\Magento\Catalog\Model\Product::ENTITY)
                ->getEntityTypeId()
            ;
            $attributes = $this->_attributeCollectionFactory->create();
            $attributes->addFieldToFilter('entity_type_id', ['eq' => $entityTypeId]);
            $attributes->setOrder('attribute_code', SortOrder::SORT_ASC);

            if (empty($attributes))
                return $this->_attributeList;

            foreach ($attributes as $attribute) {
                $this->pushChild($attribute);
            }

            return $this->_attributeList;
        }

        /**
         * @param $attribute Attribute
         */
        public function pushChild($attribute)
        {
            $this->_attributeList[$attribute->getAttributeCode()] = $attribute->getAttributeCode() . ' (' . $attribute->getDefaultFrontendLabel() . ')';
        }

    }