<?php
    /**
     * Copyright (c) 2019. IOWEB TECHNOLOGIES
     */

    /**
     * Created by IntelliJ IDEA.
     * User: gabtz
     * Date: 4/12/2017
     * Time: 9:05 μμ
     * You need to call setAttributeCode after instantiation to render the options
     */

    namespace Ioweb\Base\Model\Config\Source;


    use Magento\Eav\Model\Attribute;
    use Magento\Eav\Model\Config;
    use Magento\Eav\Model\ResourceModel\Entity\Attribute\CollectionFactory;
    use Magento\Framework\Data\OptionSourceInterface;

    class ProductAttributeOption implements OptionSourceInterface
    {


        /**
         * @var CollectionFactory
         */
        protected $_attributeCollectionFactory;

        protected $_eavConfig;

        protected $attribute_code;
        /**
         * @var $categoryList array
         */
        protected $_attributeOptionList;

        public function __construct(CollectionFactory $attributeCollectionFactory, Config $eavConfig)
        {
            $this->_attributeCollectionFactory = $attributeCollectionFactory;
            $this->eavConfig = $eavConfig;
        }


        public function toOptionArray()
        {

            $attribute = $this->eavConfig->getAttribute(\Magento\Catalog\Model\Product::ENTITY, $this->attribute_code);
            if (empty($attribute))
                return $this->_attributeOptionList;

            $options = $attribute->getSource()->getAllOptions();
            return $options;
        }

        /*
         * Option getter
         * @return array
         */

        /**
         * @return mixed
         */
        public function getAttributeCode()
        {
            return $this->attribute_code;
        }

        /*
         * Get options in "key-value" format
         * @return array
         */

        /**
         * @param mixed $attribute_code
         */
        public function setAttributeCode($attribute_code): void
        {
            $this->attribute_code = $attribute_code;
        }


    }