<?php
    /**
     * Copyright (c) 2019. IOWEB TECHNOLOGIES
     */

    /**
     * Created by IntelliJ IDEA.
     * User: gabtz
     * Date: 4/12/2017
     * Time: 9:05 μμ
     */

    namespace Ioweb\Base\Model\Config\Source;


    use Magento\Catalog\Setup\CategorySetup;
    use Magento\Eav\Model\AttributeSetRepository;
    use Magento\Framework\Api\SearchCriteriaBuilder;
    use Magento\Framework\Data\OptionSourceInterface;

    class ProductAttributeSet implements OptionSourceInterface
    {


        protected $attributeSetRepository;
        protected $searchCriteriaBuilder;

        public function __construct(AttributeSetRepository $attributeSetRepository, SearchCriteriaBuilder $searchCriteriaBuilder)
        {
            $this->attributeSetRepository = $attributeSetRepository;
            $this->searchCriteriaBuilder = $searchCriteriaBuilder;
        }

        /*
         * Option getter
         * @return array
         */
        public function toOptionArray()
        {

            $criteria = $this->searchCriteriaBuilder->addFilter('entity_type_id', CategorySetup::CATALOG_PRODUCT_ENTITY_TYPE_ID, 'eq')->create();
            $attributeSets = $this->attributeSetRepository->getList($criteria)->getItems();

            $ret = [];

            foreach ($attributeSets as $attributeSet) {
                /**
                 * @var $attributeSet \Magento\Eav\Api\Data\AttributeSetInterface
                 */
                $ret[] = [
                    'value' => $attributeSet->getAttributeSetId(),
                    'label' => $attributeSet->getAttributeSetName(),
                ];
            }

            return $ret;
        }


    }