<?php

namespace Ioweb\Base\Model\Config\Source;

use Magento\Framework\Data\OptionSourceInterface;
use Magento\Payment\Api\PaymentMethodListInterface;
use Magento\Store\Model\StoreManagerInterface;
use Magento\Shipping\Model\Config;
use \Magento\Framework\App\Config\ScopeConfigInterface;
class ShippingMethod implements OptionSourceInterface
{


    protected $shippingMethodList;
    protected $storeManager;
    protected $shippingModelConfig;

    public function __construct(
        PaymentMethodListInterface $shippingMethodList,
        StoreManagerInterface $storeManager,
        Config $shippingModelConfig,
        ScopeConfigInterface $scopeConfig
    ){
        $this->shippingMethodList = $shippingMethodList;
        $this->storeManager  = $storeManager;
        $this->shippingModelConfig = $shippingModelConfig;
        $this->_scopeConfig = $scopeConfig;

    }

    /*
     * Option getter
     * @return array
     */
    public function toOptionArray()
    {


        $arr = $this->toArray();
        $ret = [];

        foreach ($arr as $key => $value) {

            $ret[] = [
                'value' => $key,
                'label' => $value,
            ];
        }

        return $ret;
    }

    /*
     * Get options in "key-value" format
     * @return array
     */
    public function toArray()
    {
        $arr = [];

        $deliveryMethods = $this->shippingModelConfig->getAllCarriers();
        foreach ($deliveryMethods as $shippigCode => $shippingModel) {
            $shippingTitle = $shippingModel->getConfigData('title')?$shippingModel->getConfigData('title'): $shippingModel->getConfigData('name');
            $arr[$shippigCode] = $shippingTitle;
        }
        
        return $arr;

    }

}