<?php
/**
 * Copyright (c) 2017. IOWEB TECHNOLOGIES
 */

/**
 * Created by IntelliJ IDEA.
 * User: gabtz
 * Date: 4/12/2017
 * Time: 9:05 μμ
 */

namespace Ioweb\Base\Model\Config\Source;


use Magento\Framework\Data\OptionSourceInterface;
use Magento\InventoryApi\Api\Data\SourceInterface;
use Magento\InventoryApi\Api\SourceRepositoryInterface;

class Source implements OptionSourceInterface
{

    protected $sourceRepository;

    public function __construct(SourceRepositoryInterface $sourceRepository)
    {
        $this->sourceRepository = $sourceRepository;
    }

    public function toOptionArray()
    {
        $data = [];
        $data[] = [
            'label' => '__NONE__',
            'value' => null,
        ];
        $sources = $this->sourceRepository->getList();
        $items = $sources->getItems();
        foreach ($items as $item) {
            /** @var SourceInterface $item */
            $data[] = [
                'label' => sprintf("%s (%s)", $item->getName(), $item->getSourceCode()),
                'value' => $item->getSourceCode(),
            ];
        }

        return $data;
    }


}