<?php
/**
 * Copyright (c) 2017. IOWEB TECHNOLOGIES
 */

/**
 * Created by IntelliJ IDEA.
 * User: gabtz
 * Date: 4/12/2017
 * Time: 9:05 μμ
 */

namespace Ioweb\Base\Model\Config\Source;


use Magento\Framework\Data\OptionSourceInterface;
use Magento\InventoryApi\Api\Data\SourceInterface;
use Magento\InventoryApi\Api\Data\StockInterface;
use Magento\InventoryApi\Api\SourceRepositoryInterface;
use Magento\InventoryApi\Api\StockRepositoryInterface;

class Stock implements OptionSourceInterface
{

    protected $stockRepository;

    public function __construct(StockRepositoryInterface $stockRepository)
    {
        $this->stockRepository = $stockRepository;
    }

    public function toOptionArray()
    {
        $data = [];
        $data[] = [
            'label' => '__NONE__',
            'value' => null,
        ];
        $stocks = $this->stockRepository->getList();
        $items = $stocks->getItems();
        foreach ($items as $item) {
            /** @var StockInterface $item */
            $data[] = [
                'label' => sprintf("%s (%s)", $item->getName(), $item->getStockId()),
                'value' => $item->getStockId(),
            ];
        }

        return $data;
    }


}